
import java.awt.*;
import java.applet.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class 
UI extends Panel implements ActionListener 
{

   static final String POST = "PostInvitation";
   static final String REFRESH = "Refresh";
   static final String JOIN = "Join";

   Button postInvitation;
   Button sessionRefresh;
   Button sessionJoin;
   TextField nameTextField;
   Label     nameLabel;
   List      sessionList;
   clientApplet boss;
   SessionInfo sessions[];
   int         currentSessionIndex = -1;
    
   public
   UI(clientApplet _boss)
   {
      boss = _boss;

      setLayout(new GridLayout(0,2));

      sessionList = new List();
      nameTextField = new TextField(10);
      nameTextField.setEditable(true);
      nameLabel = new Label("Name");

      postInvitation = new Button(POST);
      postInvitation.setActionCommand(POST);
      postInvitation.addActionListener(this);

      sessionRefresh = new Button(REFRESH);
      sessionRefresh.setActionCommand(REFRESH);
      sessionRefresh.addActionListener(this);

      sessionJoin = new Button(JOIN);
      sessionJoin.setActionCommand(JOIN);
      sessionJoin.addActionListener(this);

      Panel p1 = new Panel();
      p1.setLayout(new GridLayout(2,0));
      Panel p11 = new Panel();
      p11.add(sessionList);
      Panel p12 = new Panel();
      p12.add(sessionRefresh);
      p12.add(sessionJoin);
      p1.add(p11);
      p1.add(p12);
      add(p1);

      Panel p4 = new Panel();
      p4.setLayout(new GridLayout(2,0));

      Panel p2 = new Panel();
      p2.add(postInvitation);

      p4.add(p2);

      Panel p3 = new Panel();
      p3.setLayout(new GridLayout(2,0));
      p3.add(nameLabel);
      p3.add(nameTextField);

      //Panel p5 = new Panel();
      //p5.add(nameTextField);
      //p3.add(p5);

      p4.add(p3);

      add(p1);
      add(p4);

   }

   public void
   updateSessionList(SessionInfo ret[])
   {
      sessionList.clear();
      if(ret!=null)
      for(int i=0;i<ret.length;i++)
      {
         sessions = ret;
         String mess = new String(sessions[i].getSessionId()+" ");
         mess += (sessions[i].getState()+" ");
         sessionList.addItem(mess);
      }// end of for

   }// end of updateSessionList()

   public String 
   getName()
   {
      String aName = nameTextField.getText();
      if(aName==null) aName = new String("Unknown");
      return aName;
   }

   public void 
   actionPerformed(ActionEvent e) 
   {
      String command = e.getActionCommand();
         
      try
      {
      if (command == POST) 
      {
         boss.postInvitation(getName());
      } 
      else if(command == REFRESH )
      {
         boss.refreshSessions();
         currentSessionIndex = -1;
      }
      else if(command == JOIN  && currentSessionIndex>-1 && sessions!=null && 
              currentSessionIndex<sessions.length )
      { 
         boss.joinSession(sessions[currentSessionIndex].getSessionId()); 
         currentSessionIndex = -1;
      }
      } catch (java.rmi.RemoteException re) {}

   }// end of actionPerformed()

   public boolean 
   handleEvent(Event event)
   {
      boolean ret = false;

      try
      {

      if(event.target instanceof Button && (Button)event.target == postInvitation ) 
      {  
         boss.postInvitation(getName());
         ret = true;
      }

      else if( event.target instanceof Button && 
               (Button)event.target == sessionJoin && 
               currentSessionIndex>-1 && 
               sessions!=null && currentSessionIndex<sessions.length ) 
      {  
         boss.joinSession(sessions[currentSessionIndex].getSessionId()); 
         currentSessionIndex = -1;
         ret = true;
      }

      else if(event.target instanceof Button && (Button)event.target == sessionRefresh ) 
      {  
         boss.refreshSessions();
         currentSessionIndex = -1;
         ret = true;
      }

      else if(event.target instanceof List ) 
           {
              List list = (List) event.target;
              
              System.out.println(" On LIst "+event.id);
              System.out.println(" Event.LIST_SELECT "+Event.LIST_SELECT);

              switch(event.id)
              {
                 case Event.LIST_SELECT:  
                      currentSessionIndex = ((Integer)event.arg).intValue();
                      System.out.println(" will join the session "+currentSessionIndex);
                      break;

              }// end of switch()

              ret = true;

           }

      } catch (java.rmi.RemoteException re) {}

      return (ret);

   }// end of action

}// end of UI

